<?php
namespace Teknisa\CRM\Service;


class ABAgendaService {
    
    protected $newCode;
    protected $agendaFactory;
    
    public function __construct ($agendaFactory, $newCode){
        
        $this->agendaFactory   = $agendaFactory;
        $this->newCode           = $newCode;
    }
    
    public function generalInsertTask($row){
// var_dump( $row["NRSEQCLASSIFICATAREFA"]);die();
        $paramsInsertTask = array(
            "DSFILACONTATO"         => $row["DSFILACONTATO"],
            "DTPLANFILACONTA"       => $row["DTPLANFILACONTA"],
            "CDOPERREAL"            => $row["CDOPERREAL"],
            "NRSEQFILACONTA"        => $row["NRSEQFILACONTA"],
            "NRORG"                 => $row["NRORG"],
            "NRORGINCLUSAO"         => $row["NRORG"],
            "CDOPERINCLUSAO"        => $row["CDOPEREVOL"],
            "NRPARCNEGOCIO"         => $row["NRPARCNEGOCIO"],
            "NRCONTATO"             => $row["NRSEQCONTATO"],
            "NRSEQCONTATO"          => $row["NRSEQCONTATO"],
            "NRSEQCLASSIFICATAREFA" => $row["NRSEQCLASSIFICATAREFA"],
            "NRSEQINTERLOCUTOR"         => empty($row['NRSEQINTERLOCUTOR']) ? '' : $row['NRSEQINTERLOCUTOR'],
            "DSEMAILTAREFA"             => empty($row['EMAILINTERLOC']) ? '' : $row['EMAILINTERLOC'],
            "DSTELEFONETAREFA"          => empty($row['NRTELEFONE1']) ? '' : $row['NRTELEFONE1'],
        );
        
        try{
            $retorno = $this->agendaFactory->generalInsertTask($paramsInsertTask);
        }catch(\Exception $retorno){
            return $retorno->getMessage();
        }
        return $retorno;
    }
}