<?php
namespace Teknisa\CRM\Service;


class DashboardService {
    
    protected $dashboardFactory;
    
    public function __construct ($dashboardFactory){
        
        $this->dashboardFactory    = $dashboardFactory;
    }
    
    public function getPivotedTermometro($params){
        
        $colors = $params['P_COLORS'].",'SEMTERM'";
        $nrorg  = $params['P_NRORG'];
        $opers  = $params['P_NRPARCOPERSHIERARQINF'];
        
        $return = $this->dashboardFactory->getPivotedTermometro($nrorg, $opers, $colors);
        $sum = 0;
        foreach ($return as &$rows) {
            foreach ($rows as $key => $row) {
                if(is_numeric($row) && $key != 'CDOPERADOR' && $key != 'NRPARCNEGOCIO')
                    $sum+=$row;
            }
            foreach ($rows as $key => $row) {
                if(is_numeric($row) && $key != 'CDOPERADOR' && $key != 'NRPARCNEGOCIO'){
                    $percent = ($row/$sum)*100;
                    $rows[$key] = $percent;
                }
            }
            $sum = 0;
        }
        
        return $return;
        
    }
}