<?php
/**
 * Created by PhpStorm.
 * User: gustavolima
 * Date: 14/09/2015
 * Time: 14:59
 */

namespace Teknisa\CRM\Service;
use Doctrine\ORM\EntityManager;


class crm00038000IndicadorDesempenhoService {

    /** @var  EntityManager */
    protected $entityManager;
    /** @var  Environment */
    protected $environment;

    public function __construct($entityManager, $environment) {
        $this->entityManager = $entityManager;
        $this->environment = $environment;
    }

    public function getRowsByFilter(array $filterValues)
    {
        $where = "";

        foreach($filterValues as $valuesToFilter)
        {
            if ($valuesToFilter['columnName']=='NRORG') {
                $where .= " AND APL." . $valuesToFilter['columnName'] . " = " . $valuesToFilter['value'];
            }
            else {
                $where .= " AND APL." . $valuesToFilter['columnName'] . " IN ('";
                foreach($valuesToFilter['value'] as $valor)
                {
                    $where .= $valor."','";
                }
                $where = substr($where,0,strlen($where)-2).") ";
            }
        }

        $sql = "SELECT COUNT(*)       AS QTDEOPER,
                  APL.NMPRINCIPALPARC AS AVALIADO,
                  PART.NRPARCAVALIADO AS NRAVALIADO
                FROM AVALIACAOGERAL AVAL
                JOIN PARTICIPAVAL PART
                ON AVAL.IDSITUACAOAVALIACAO = 'CONCLUIDA'
                AND AVAL.NRAVALIACAO = PART.NRAVALIACAO
                AND AVAL.NRORG      = PART.NRORG
                JOIN PARCNEGOCIO EXE
                ON PART.NRPARCEXECAVAL = EXE.NRPARCNEGOCIO
                AND AVAL.NRORG         = EXE.NRORG
                JOIN TIPORELACIONA TIP
                ON PART.NRTIPORELACIONA = TIP.NRTIPORELACIONA
                AND PART.NRORG          = TIP.NRORG
                AND UPPER(TIP.NMTIPORELACIONA) LIKE 'PARTICIPANTE_CRM'
                JOIN PARCNEGOCIO APL
                ON PART.NRPARCAVALIADO = APL.NRPARCNEGOCIO
                AND AVAL.NRORG         = APL.NRORG";
        $sql .= $where;
        $sql .= " GROUP BY PART.NRPARCAVALIADO, APL.NMPRINCIPALPARC, PART.NRPARCAVALIADO";
        $std = $this->entityManager->getConnection()->prepare($sql);
        $std->execute();
        $dataSet = $std->fetchAll();

        return $dataSet;
    }
}