function crm_cadastro_slaController(CRM_Utilities, General, templateManager, ScreenService, restEngine, localStorageEngine, metaDataFactory) {

    var self = this;

    this.campos = function(DSPRIORIDADE, PK) {
        var campos = [
            {
                "id": "",
                "name": "DSPRIORIDADE" + DSPRIORIDADE,
                "label": "Prioridade",
                "template": "field/text-edit.html",
                "fieldGroup": "PRIORIDADE",
                "class": "2",
                "descriptionField": PK,
                "defaultValue": DSPRIORIDADE,
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": true,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "RESPONDER" + DSPRIORIDADE,
                "label": "Responder em",
                "template": "field/number-edit.html",
                "fieldGroup": "PRIORIDADE",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": false,
                "class": "textSelect",
                "validations": {
                    "required": true
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
         
            },
            {
                "id": "",
                "name": "RESPONDER" + DSPRIORIDADE+"_OPTION",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "TPHORATRAB",
                "hideEmptyValue": true,
                "descriptionField": "DESCRICAO",
                "defaultValue": 1,
                "isVisible": true,
                "showOnList": false,
                "showOnView": false,
                "class": "selectText",
                "dataSource": {
                    "data": [
                        {
                            "TPHORATRAB": 1,
                            "DESCRICAO": "Min."
                        },
                        {
                            "TPHORATRAB": 2,
                            "DESCRICAO": "Hora (s)"
                        },
                        {
                            "TPHORATRAB": 3,
                            "DESCRICAO": "Dias Úteis"
                        },
                        {
                            "TPHORATRAB": 4,
                            "DESCRICAO": "Dias Corridos"
                        },
                        {
                            "TPHORATRAB": 5,
                            "DESCRICAO": "Meses"
                        }
                    ]
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],      
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
                
            },
            {
                "id": "",
                "name": "RESOLVER" + DSPRIORIDADE,
                "label": "Resolver em",
                "template": "field/number-edit.html",
                "fieldGroup": "PRIORIDADE",
                "isVisible": true,
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "readOnly": false,
                "class": "textSelect",
                "validations": {
                    "required": true
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
         
            },
            {
                "id": "",
                "name": "RESOLVER" + DSPRIORIDADE+"_OPTION",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "TPHORATRAB",
                "hideEmptyValue": true,
                "defaultValue": 1,
                "descriptionField": "DESCRICAO",
                "isVisible": true,
                "showOnList": false,
                "showOnView": false,
                "class": "selectText",
                "dataSource": {
                    "data": [{
                            "TPHORATRAB": 1,
                            "DESCRICAO": "Min."
                        },
                        {
                            "TPHORATRAB": 2,
                            "DESCRICAO": "Hora (s)"
                        },
                        {
                            "TPHORATRAB": 3,
                            "DESCRICAO": "Dias Úteis"
                        },
                        {
                            "TPHORATRAB": 4,
                            "DESCRICAO": "Dias Corridos"
                        },
                        {
                            "TPHORATRAB": 5,
                            "DESCRICAO": "Meses"
                        }
                    ]
                },
                "events": [
                        {
                        "id": "",
                        "name": "FieldOnChange",
                        "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                        }
                ],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "NRHORATRAB" + DSPRIORIDADE,
                "label": "Horário Operação",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "NRHORATRAB",
                "hideEmptyValue": true,
                "descriptionField": "NMHORARIO",
                "dataSource": {
                    "name": "product#/crud/crm_horatrab",
                    "rest": true,
                    "lazyLoad": false
                },
                "defaultValue": null,
                "validations": {
                    "required": true
                },
                "isVisible": true,
                "showOnList": false,
                "class": "2",
                "events": [{
                    "id": "",
                    "name": "FieldOnChange",
                    "code": "crm_cadastro_slaController.verificaMaiorMenor(args); crm_cadastro_slaController.setAviso(args);"
                }],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "MANDAEMAIL" + DSPRIORIDADE,
                "label": "E-mail",
                "template": "field/select-native.html",
                "fieldGroup": "PRIORIDADE",
                "valueField": "MANDAEMAIL",
                "hideEmptyValue": true,
                "descriptionField": "DESCRICAO",
                "dataSource": {
                    "data": [
                        {
                            "MANDAEMAIL": "1",
                            "DESCRICAO": "Envia Lembrete"
                        },
                        {
                            "MANDAEMAIL": "2",
                            "DESCRICAO": "Envia Notificação"
                        },
                        {
                            "MANDAEMAIL": "3",
                            "DESCRICAO": "Envia Ambos"
                        },
                        {
                            "MANDAEMAIL": "4",
                            "DESCRICAO": "Não Envia"
                        }
                    ]
                },
                "defaultValue": "2",
                "isVisible": true,
                "showOnList": false,
                "class": "2",
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "name": "DSPRIORIDADECLI",
                "label": "Prioridade",
                "template": "field/select.html",
                "class": "3",
                "isVisible": false,
                "showOnList": false,
                "showOnView": false,
                "showOnForm": false,
                "readOnly": false,
                "dataSource": {
                    "name": "product#/crud/crm_prioridade",
                    "rest": true,
                    "lazyLoad": false
                },
                "itemsPerPage": 50,
                "dataSourceFilter": [{
                        "name": "NRORG",
                        "operator": "IN",
                        "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
                    },
                    {
                        "name": "IDATIVO",
                        "operator": "=",
                        "value": "S"
                    }
                ],
                "descriptionField": "DSPRIORIDADECLI",
                "valueField": "NRPRIORIDADE",
                "outData": {
                    "NRPRIORIDADE": "NRPRIORIDADE",
                    "DSPRIORIDADECLI": "DSPRIORIDADECLI"
                },
                "fields": [{
                    "name": "DSPRIORIDADECLI",
                    "label": "Prioridade",
                    "showOnList": true
                }],
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "AVISO" + DSPRIORIDADE,
                "defaultValue": "",
                "template": "field/span-field.html",
                "class": "12 avisoTempoResposta",
                "isVisible": true,
                "fieldGroup": "PRIORIDADE",
                "showOnList": false,
                "showOnView": true,
                "showOnForm": true,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            },
            {
                "id": "",
                "name": "NRORG" + DSPRIORIDADE,
                "defaultValue": "@templateManager.LOGGEDOPERATOR.NRORG@",
                "template": "field/text-edit.html",
                "class": "1",
                "isVisible": false,
                "fieldGroup": "PRIORIDADE",
                "showOnList": false,
                "showOnView": false,
                "showOnForm": false,
                "events": [],
                "filterProperties": {
                        "showOnList": false,
                        "showOnForm": false,
                        "showOnView": false,
                        "isVisible": false,
                        "class": "3"
                    }
            }

        ];
        return campos;
    };

    this.nomePrioridades = function() { /*Pega as prioridades criadas*/
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;
        var rows = [];
        rows = prioridades.map(function(row) { /*Pega nome das priorirades*/
            return row['DSPRIORIDADECLI'];
        });
        return rows;
    };

    this.PkPrioridades = function() { /*Pega as prioridades criadas*/
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;
        var rows = [];
        rows = prioridades.map(function(row) { /*Pega nome das priorirades*/
            return row['NRPRIORIDADE'];
        });
        return rows;
    };

    this.listaPrioridade = function() {

        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
        var prioridades = widget.getField('DSPRIORIDADECLI').dataSource.data;

        var cammposfield = [];

        var rowsPk = self.PkPrioridades();
        var rows = self.nomePrioridades();
        var num = 0;

        cammposfield = prioridades.map(function(row) {
            var fields = self.campos(rows[num], rowsPk[num]);
            num++;
            return fields;
        });

        return cammposfield;
    };

    this.insertFields = function(arrayOfFields, widget) {
        arrayOfFields.forEach(function(field, index) {
            if (index > 6) { //tira label dos campos 
                field.label = undefined;
            }
            field.dynamic = true;
            metaDataFactory.fieldFactory(field, widget, true);
        });
    };

    this.ativaFieldPrioridade = function() {
        var widget = templateManager.container.getWidget('WDGT_CADASTRO_SLA');

        var arrayFields = self.listaPrioridade();

        if (arrayFields == "") {
            //  ScreenService.showMessage('Prioridade não cadastrada');
        } else {
            var fieldsFixo = 5; /*Quantidade de Fields que esta no Json */
            var qntObjArray = arrayFields.length; /*Quantidade de Objetos dentro do array principal de campos*/
            var qntObjSubArray = arrayFields[0].length; /*Quantidade de Objetos dentro do sub array do principal de campos*/
            var totalField = qntObjArray * qntObjSubArray + fieldsFixo; /*Total de field que deve ter*/

            if (widget.fields.length < totalField) { /*Verifica se os campos foram criados*/
                var Fields = arrayFields[0];
                for (var i = 1; i < arrayFields.length; i++) {
                    Fields = Fields.concat(arrayFields[i]);
                }
                self.insertFields(Fields, widget);
            }
        }


    };

    this.salvaSLA = function(widget) {
        if (widget.currentRow.__is_new == true) {

              
                var prioridades = self.nomePrioridades();
                var fieldPrioridades = [];

                fieldPrioridades = prioridades.map(function(prioridade) {
                    var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');

                    var tempoResp       = wid.currentRow['RESPONDER' + prioridade];
                    var tempoTextResp   = wid.currentRow['RESPONDER' + prioridade];
                    var tipoResp        = wid.currentRow['RESPONDER' + prioridade + '_OPTION'];
 
                    var tempoResv       = wid.currentRow['RESOLVER' + prioridade];
                    var tempoTextResv   = wid.currentRow['RESOLVER' + prioridade];
                    var tipoResv        = wid.currentRow['RESOLVER' + prioridade + '_OPTION'];
        

                    if (tipoResp == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResp = tempoResp;

                    } else if (tipoResp == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResp = tempoResp * 60;
                        tempoResp = tempoTextResp;
                    } else if (tipoResp == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;

                    } else if (tipoResp == 4) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;
                        
                    } else if (tipoResp == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24 * 30;
                        tempoResp = tempoTextResp;
                    }



                    if (tipoResv == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResv = tempoResv;

                    } else if (tipoResv == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResv = tempoResv * 60;
                        tempoResv = tempoTextResv;
                    } else if (tipoResv == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    } else if (tipoResv == 4) { 
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    }else if (tipoResv == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResv = tempoResv * 60 * 24 * 30;
                        tempoResv = tempoTextResv;
                    }

                    wid.currentRow['RESPONDER' + prioridade] = tempoResp;
                    wid.currentRow['RESOLVER' + prioridade] = tempoResv;
                    wid.currentRow['RESOLVER' + prioridade + '_TEXT'] = tempoTextResv;

                    var fieldsPrioridade = new Object();
                    fieldsPrioridade.NRORG              = wid.currentRow['NRORG' + prioridade];
                    fieldsPrioridade.DSPRIORIDADE       = wid.getField('DSPRIORIDADE' + prioridade).descriptionField;
                    fieldsPrioridade.NRHORATRAB         = wid.currentRow['NRHORATRAB' + prioridade];
                    fieldsPrioridade.RESPONDER          = wid.currentRow['RESPONDER' + prioridade];
                    fieldsPrioridade.RESPONDEREAL       = wid.currentRow['RESPONDER'+'REAL'+prioridade];
                    fieldsPrioridade.RESPONDER_OPTION   = wid.currentRow['RESPONDER' + prioridade + '_OPTION'];
                    fieldsPrioridade.RESOLVER           = wid.currentRow['RESOLVER' + prioridade];
                    fieldsPrioridade.RESOLVER_OPTION    = wid.currentRow['RESOLVER' + prioridade + '_OPTION'];
                    fieldsPrioridade.RESOLVEREAL        = wid.currentRow['RESOLVER' +'REAL'+ prioridade];
                    fieldsPrioridade.MANDAEMAIL         = wid.currentRow['MANDAEMAIL' + prioridade];
                    fieldsPrioridade.AVISO              = wid.currentRow['AVISO' + prioridade];

                    return fieldsPrioridade;


                });

                var dataset     = {};
                dataset.SLA     = widget.currentRow;
                dataset.rows    = fieldPrioridades;

                General.callRestEngine("product#/crm_sla_vincula/sla_prioridade_SLA", "DataSet", [dataset]).then(function(response) {
                    ScreenService.closeSwipe().then(function() {
                        widget.reload();
                    });

                }.bind(this));

            
        } else {
            var prioridades = self.nomePrioridades();
            var row = widget.currentRow;
            var dataset = {};
            var fieldsSLA = new Object();
            fieldsSLA.DSSLA = row.DSSLA;
            fieldsSLA.NMSLA = row.NMSLA;
            fieldsSLA.NRSEQSLA = row.NRSEQSLA;
            fieldsSLA.NRORG = row.NRORG;

            dataset.sla = fieldsSLA;
            dataset.prioridade = prioridades.map(function(prioridade) {
                var row = templateManager.container.getActiveWidget().currentRow;

                var tipoResp =  row['RESPONDER' + prioridade+'_OPTION'];
                var tempoTextResp = row['RESPONDER' + prioridade];
                var tempoResp = row['RESPONDER' + prioridade];
                if (tipoResp == 1) { /*Se o tempo estiver em mintos*/
                    tempoTextResp = tempoResp;

                } else if (tipoResp == 2) { /*Se o tempo estiver em horas*/
                    tempoTextResp = tempoResp * 60;
                    tempoResp = tempoTextResp;
                } else if (tipoResp == 3) { /*Se o tempo estiver em dias*/
                    tempoTextResp = tempoResp * 60 * 24;
                    tempoResp = tempoTextResp;
                } else if (tipoResp == 4) { /*Se o tempo estiver em meses*/
                     tempoTextResp = tempoResp * 60 * 24;
                    tempoResp = tempoTextResp;
                }else if (tipoResp == 5) { /*Se o tempo estiver em meses*/
                    tempoTextResp = tempoResp * 60 * 24 * 30;
                    tempoResp = tempoTextResp;
                }




                var tipoResv = row['RESOLVER' + prioridade+'_OPTION'];
                var tempoTextResv = row['RESOLVER' + prioridade];
                var tempoResv = row['RESOLVER' + prioridade];
                if (tipoResv == 1) { /*Se o tempo estiver em mintos*/
                    tempoTextResv = tempoResv;

                } else if (tipoResv == 2) { /*Se o tempo estiver em horas*/
                    tempoTextResv = tempoResv * 60;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 3) { /*Se o tempo estiver em dias*/
                    tempoTextResv = tempoResv * 60 * 24;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 4) { /*Se o tempo estiver em meses*/
                    tempoTextResv = tempoResv * 60 * 24;
                    tempoResv = tempoTextResv;
                } else if (tipoResv == 5) { /*Se o tempo estiver em meses*/
                    tempoTextResv = tempoResv * 60 * 24 * 30;
                    tempoResv = tempoTextResv;
                }

                var fieldsPrioridade = new Object();
                fieldsPrioridade.NRSLAPRIORIDADE    = row['NRSLAPRIORIDADE' + prioridade];
                fieldsPrioridade.RESOLVER           = tempoTextResv;
                fieldsPrioridade.RESPONDER          = tempoTextResp;
                fieldsPrioridade.MANDAEMAIL         = row['MANDAEMAIL' + prioridade];
                fieldsPrioridade.NRHORATRAB         = row['NRHORATRAB' + prioridade];
                fieldsPrioridade.TPRESOLVER         = tipoResv;
                fieldsPrioridade.TPRESPONDER        = tipoResp;
                fieldsPrioridade.NRORG              = row.NRORG;
                fieldsPrioridade.NRSEQSLA           = row.NRSEQSLA;
                fieldsPrioridade.AVISO              = row['AVISO' + prioridade];
                fieldsPrioridade.RESPONDEREAL       = row['RESPONDER'+'REAL'+prioridade];
                fieldsPrioridade.RESOLVEREAL        = row['RESOLVER' +'REAL'+ prioridade];
                return fieldsPrioridade;

            });

            General.callRestEngine("product#/crm_sla_vincula/sla_update", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                });

            }.bind(this));
        }

    };

    this.inativarSLA = function(widget) {
                                        
        ScreenService.confirmMessage('Deseja realmente Inativar a SLA?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_vincula/sla_inativar', paramsRestEngine).
                then(function(response) {

                    ScreenService.showMessage('SLA Inativada');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });
    };

    this.setPrioridade = function() {
        var widget = templateManager.container.getActiveWidget();
      
        setTimeout(function() {
            if (widget.mode === "view") {
                var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE');
                var NRSEQSLA = widget.currentRow.NRSEQSLA;
                restEngine.post("product#/crud/crm_slaprioridade", {
                    'requestType': 'FilterData',
                    filter: [{
                        operator: "=",
                        name: "NRSEQSLA",
                        value: NRSEQSLA
                    }]
                }).
                then(function(response) {

                    var slaprioridades = response.dataset.crm_slaprioridade;
                    slaprioridades.forEach(function(slaprioridade) {

                        var nmPrioridade = slaprioridade.DSPRIORIDADECLI;

                        var responderTipo   = parseInt(slaprioridade.IDTPRESPONDER);
                        var resolverTipo    = parseInt(slaprioridade.IDTPRESOLVER);
                        var responderQntmin = parseInt(slaprioridade.NRTEMPORESPSLA);
                        var resolverQntmin  = parseInt(slaprioridade.NRTEMPOSOLUSLA);
                        var responderTratado;
                        var resolverTratado;

                        if (responderTipo == 1) { /*Se o tempo estiver em mintos*/
                            responderTratado = responderQntmin + ' Minuto(s)';

                        } else if (responderTipo == 2) { /*Se o tempo estiver em horas*/
                            responderTratado = (responderQntmin / 60) + ' Hora(s)';

                        } else if (responderTipo == 3) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24) + ' Dias Uteis';

                        } else if (responderTipo == 4) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24) + ' Dias Corridos';

                        } else if (responderTipo == 5) { /*Se o tempo estiver em dias*/
                            responderTratado =(responderQntmin / 60 / 24 / 30) + ' Mes(es)';

                        }

                        if (resolverTipo == 1) { /*Se o tempo estiver em mintos*/
                            resolverTratado = resolverQntmin + ' Minuto(s)';

                        } else if (resolverTipo == 2) { /*Se o tempo estiver em horas*/
                            resolverTratado = (resolverQntmin / 60) + ' Hora(s)';

                        } else if (resolverTipo == 3) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60 / 24) + ' Dia Uteis';

                        } else if (resolverTipo == 4) { /*Se o tempo estiver em meses*/
                            resolverTratado = (resolverQntmin / 60 / 24) + ' Dias Corridos';

                        } else if (resolverTipo == 5) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin  / 60 / 24 / 30) + ' Mes(es)';

                        }

                        widget.currentRow['DSPRIORIDADE' + nmPrioridade]        = slaprioridade.DSPRIORIDADECLI;
                        widget.currentRow['RESPONDER' + nmPrioridade]           = responderTratado;
                        widget.currentRow['RESPONDER' + nmPrioridade+'_OPTION'] = responderTipo
                        widget.currentRow['RESOLVER' + nmPrioridade]            = resolverTratado;
                        widget.currentRow['RESOLVER' + nmPrioridade+'_OPTION']  = resolverTipo
                        widget.currentRow['NRHORATRAB' + nmPrioridade]          = slaprioridade.NRHORATRAB;
                        widget.currentRow['MANDAEMAIL' + nmPrioridade]          = slaprioridade.IDENVIAREMAIL;
                        widget.currentRow['AVISO' + nmPrioridade]               = slaprioridade.DSTPREAL;

                    }.bind(this));
                }.bind(this));
                wid.enabled = true;
                
                if(widget.currentRow.IDATIVO == "N"){
                    widget.getAction('DELETE').label = "Ativar";
                    widget.getAction('EDIT').isVisible = true;
                    wid.template = "widget/grid.html" ;
                    wid.actions.forEach(function(action){
                        action.isVisible = false;
                    });
                }else{
                    widget.getAction('DELETE').label = "Inativar";
                    widget.getAction('EDIT').isVisible = true;
                    wid.template = "widget/master_detail/grid.html";
                    wid.actions.forEach(function(action){
                        action.isVisible = true;
                    });
                }
                setTimeout(function() {
                    widget.reload();
                }, 4);
            } else if (widget.mode === "edit") {

                var NRSEQSLA = widget.currentRow.NRSEQSLA;
                restEngine.post("product#/crud/crm_slaprioridade", {
                    'requestType': 'FilterData',
                    filter: [{
                        operator: "=",
                        name: "NRSEQSLA",
                        value: NRSEQSLA
                    }]
                }).
                then(function(response) {

                    var slaprioridades = response.dataset.crm_slaprioridade;
                    slaprioridades.forEach(function(slaprioridade) {

                        var nmPrioridade = slaprioridade.DSPRIORIDADECLI;

                        var responderTipo   = parseInt(slaprioridade.IDTPRESPONDER);
                        var resolverTipo    = parseInt(slaprioridade.IDTPRESOLVER);
                        var responderQntmin = parseInt(slaprioridade.NRTEMPORESPSLA);
                        var resolverQntmin  = parseInt(slaprioridade.NRTEMPOSOLUSLA);
                        var responderTratado;
                        var resolverTratado;

                        if (responderTipo == 1) { /*Se o tempo estiver em mintos*/
                            responderTratado = parseInt(responderQntmin);

                        } else if (responderTipo == 2) { /*Se o tempo estiver em horas*/
                            responderTratado = (responderQntmin / 60);

                        } else if (responderTipo == 3) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24);

                        } else if (responderTipo == 4) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 60 / 24);
                            
                        } else if (responderTipo == 5) { /*Se o tempo estiver em dias*/
                            responderTratado = (responderQntmin / 24 / 30);
                        }

                        if (resolverTipo == 1) { /*Se o tempo estiver em mintos*/
                            resolverTratado = parseInt(resolverQntmin);

                        } else if (resolverTipo == 2) { /*Se o tempo estiver em horas*/
                            resolverTratado = (resolverQntmin / 60);

                        } else if (resolverTipo == 3) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60 / 24);

                        } else if (resolverTipo == 4) { /*Se o tempo estiver em dias*/
                            resolverTratado = (resolverQntmin / 60  / 24);
                            
                        } else if (resolverTipo == 5) { /*Se o tempo estiver em meses*/
                            resolverTratado = (resolverQntmin / 60 / 24 / 30);
                        }

                        widget.currentRow['DSPRIORIDADECLI' + nmPrioridade] = slaprioridade.DSPRIORIDADECLI;
                        widget.currentRow['RESPONDER' + nmPrioridade]       = parseInt(responderTratado);
                        widget.currentRow['TPRESPONDER' + nmPrioridade]     = parseInt(slaprioridade.IDTPRESPONDER);
                        widget.currentRow['RESOLVER' + nmPrioridade]        = parseInt(resolverTratado);
                        widget.currentRow['TPRESOLVER' + nmPrioridade]      = parseInt(slaprioridade.IDTPRESOLVER);
                        widget.currentRow['NRHORATRAB' + nmPrioridade]      = slaprioridade.NRHORATRAB;
                        widget.currentRow['NRHORATRAB' + nmPrioridade]      = slaprioridade.NRHORATRAB;
                        widget.currentRow['MANDAEMAIL' + nmPrioridade]      = slaprioridade.IDENVIAREMAIL;
                        widget.currentRow['NRSLAPRIORIDADE' + nmPrioridade] = slaprioridade.NRSLAPRIORIDADE;


                    }.bind(this));
                }.bind(this));
            }
        }, 4)

    };

    this.openSwipeCliente = function() {
        var widget = templateManager.container.getWidget('WDGT_CLIENTES');
        ScreenService.openSwipe(widget);
    };
    
    this.openSwipeProduto = function() {
        var widget = templateManager.container.getWidget('WDGT_PRODUTOS');
        ScreenService.openSwipe(widget);
    };

    this.vincularCliente = function(widget) {

        var dataset = {};
        dataset.rows = widget.getCheckedRows();
        dataset.nrseqsla = templateManager.container.getWidget('WDGT_CADASTRO_SLA').currentRow.NRSEQSLA;


        if (dataset.rows && dataset.rows.length !== 0) {

            var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE');
             
            var clientes = widget.getCheckedRows();
            
            var NRPARCNEGOCIO = clientes.map(function(cliente) {
                    return cliente.NRPARCNEGOCIO;
            });
            var NRSEQSLA = wid.currentRow.NRSEQSLA;
            restEngine.post("product#/crud/crm_vinculoSlaCliente", {
                'requestType': 'FilterData',
                filter: [
                    {
                    operator: "IN",
                    name: "NRPARCNEGOCIO",
                    value: NRPARCNEGOCIO
                    },
                    {
                    operator: "=",
                    name: "NRSEQSLA",
                    value: ""
                    }
                ]
            }).
            then(function(response) {
                var clienteJaVinculados = response.dataset.crm_vinculoSlaCliente;
                
                if(clienteJaVinculados.length == 0){
                    
                    General.callRestEngine("product#/crm_sla_vincula/sla_vinculo", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                    wid.reload();
                });

            }.bind(this));
                }else{
                    ScreenService.showMessage('Cliente ja em SLA');
                }
            }.bind(this));


        } else {
            ScreenService.showMessage('Selecione um cliente');

        }
    };

    this.deleteCliente = function(widget) {
        ScreenService.confirmMessage('Deseja realmente desvincular o Cliente à SLA?', 'QUESTION',
            function(success) {
                var paramsRestEngine = {
                    requestType: 'Row',
                    row: widget.currentRow
                };

                restEngine.post('product#/crm_sla_vincula/sla_vinculo_delete', paramsRestEngine).
                then(function(response) {

                    ScreenService.showMessage('Cliente desvinculado');
                    ScreenService.closeSwipe().then(function() {
                        ScreenService.closePopup(true);
                        widget.reload();
                    });

                }).catch(function(error) {
                    ScreenService.showMessage(error.data.error);
                });
            },
            function(cancel) {

            });



    };

    this.mensagemAvisoMinuto = function(dia, hora, minuto) {
        var msg;
        if (dia == 0) {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = minuto + " Minuto ";
                } else {
                    msg = minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                        if (minuto == 0) {
                        msg = hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        } else if (dia == 1) {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = dia + " Dia e " + minuto + " Minuto ";
                } else if (minuto == 0) {
                    msg = dia + " Dia";
                } else {
                    msg = dia + " Dia e " + minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = dia + " Dia e " + hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = dia + " Dia, " + hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dia,  " + hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                    if (minuto == 0) {
                        msg = dia + " Dia e " + hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = dia + " Dia, " + hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dia,  " + hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        } else {
            if (hora == 0) {
                if (minuto == 1) {
                    msg = dia + " Dias e " + minuto + " Minuto ";
                } else if (minuto == 0) {
                    msg = dia + " Dias";
                } else {
                    msg = dia + " Dias e " + minuto + " Minutos ";
                }
            } else {
                if (hora == 1) {
                    if (minuto == 0) {
                        msg = dia + " Dias e " + hora + " Hora ";
                    } else if (minuto == 1) {
                        msg = dia + " Dias, " + hora + " Hora e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dias,  " + hora + " Hora e " + minuto + " Minutos";
                    }
                } else {
                    if (minuto == 0) {
                        msg = dia + " Dias e " + hora + " Horas ";
                    } else if (minuto == 1) {
                        msg = dia + " Dias, " + hora + " Horas e " + minuto + " Minuto";
                    } else {
                        msg = dia + " Dias,  " + hora + " Horas e " + minuto + " Minutos";
                    }
                }
            }

        }

        return msg;
    };

    this.mensagemAvisoMes = function(mes, dia) {
        var msg;

        if (dia == 0) {
            if (mes == 1) {
                msg = mes + " Mes ";
            } else {
                msg = mes + " Meses ";
            }
        } else {
            if (mes == 1) {
                if (dia == 1) {
                    msg = mes + " Mes e " + dia + " Dia ";
                } else {
                    msg = mes + " Mes e " + dia + " Dias ";
                }
            } else if (mes == 0) {
                if (dia == 1) {
                    msg = dia + " Dia ";
                } else {
                    msg = dia + " Dias ";
                }
            } else {
                if (dia == 1) {
                    msg = mes + " Meses e " + dia + " Dia ";
                } else {
                    msg = mes + " Meses e " + dia + " Dias ";
                }
            }
        }
        return msg;
    };

    this.calculaMinuto = function(widget, preFixCampo, prioridadeNomeResp, qntHRStrab) {
        var tempoMsg;
        var qntMinSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        for (var i = 0; i < qntHRStrab.length; i++) {
            var minTrab = qntHRStrab[i] * 60 / 100;

            if (qntMinSet > 0 && i + 1 < qntHRStrab.length) {
                qntMinSet = qntMinSet - minTrab;
                var d = i;

            } else {
                if (qntMinSet == 0) {
                    var dias = d + 1;
                    tempoMsg = self.mensagemAvisoMinuto(dias, 0, 0);
                    var minDReal = dias*24*60;
                    widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;

                } else {
                    var dias = d;
                    var minutosHora = qntMinSet + qntHRStrab[i-1] * 60 / 100;
                    if (minutosHora >= 60) {
                        var horaMinutos = parseInt(minutosHora / 60);
                        minutosHora = minutosHora - (horaMinutos * 60);
                        if (minutosHora == 0) {
                            tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, 0);
                            var minHReal = horaMinutos *  60;
                            var minDReal = (dias*24*60) + minHReal;
                            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                             break;
                        } else {
                            tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, minutosHora);
                            var minHReal = horaMinutos *  60;
                            var minDReal = (dias*24*60) + minHReal + parseInt(minutosHora);
                            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                            break;
                        }
                    } else {
                        tempoMsg = self.mensagemAvisoMinuto(dias, 0, minutosHora);
                        var minDReal = (dias*24*60) + parseInt(minutosHora);
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                        break;
                    }
                }

               
            }
        }
        return tempoMsg;
    };

    this.calculaHora = function(widget, preFixCampo, prioridadeNomeResp, qntHRStrab) {
        var tempoMsg;
        var qntHoraSet = widget.currentRow[preFixCampo + prioridadeNomeResp] * 100;
        for (var i = 0; i < qntHRStrab.length; i++) {
            if (qntHoraSet > 0 && i + 1 < qntHRStrab.length) {
                qntHoraSet = qntHoraSet - qntHRStrab[i];
                var h = i;
            } else {
                if (qntHoraSet == 0) {
                    var dias = h + 1;
                    tempoMsg = self.mensagemAvisoMinuto(dias, 0, 0);
                    var minDReal = dias*24*60;
                    widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                     
                } else {
                    qntHoraSet = (qntHoraSet + qntHRStrab[h]) / 100;
                    var dias = h;
                    var horaMinutos = Math.round(qntHoraSet);
                    var minutosHora = Math.round(qntHoraSet) * 100 - (qntHoraSet * 100);
                    if (minutosHora == 0) {
                        tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, 0);
                        var minHReal = horaMinutos *  60;
                        var minDReal = (dias*24*60) + minHReal;
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                    } else {
                        tempoMsg = self.mensagemAvisoMinuto(dias, horaMinutos, parseInt(minutosHora));
                        var minHReal = horaMinutos *  60;
                        var minDReal = (dias*24*60) + minHReal + parseInt(minutosHora);
                        widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
                    }

                }
                break;
            }
        }
        return tempoMsg;
    };

    this.calculaDiaUtil = function(widget, preFixCampo, prioridadeNomeResp, diasAbertos) {
        var tempoMsg;
        var qntDiaSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        var qntDiaAberto = diasAbertos.length;
        var qntSemana = parseInt(qntDiaSet / qntDiaAberto);
        if (qntSemana == qntDiaSet / qntDiaAberto) {
            qntSemana = qntSemana - 1
        };
        var qntDiaSemana = (qntSemana * 7) - qntDiaSet;
        var diferencaDias = (qntSemana * 7) - (qntSemana * qntDiaAberto);
        qntDiaSet = qntDiaSet + diferencaDias;

        if (qntDiaSet >= 30) {
            var qntMesSet = parseInt(qntDiaSet / 30);
            qntDiaSet = qntDiaSet - (qntMesSet * 30);
            if (qntDiaSet == 0) {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, 0);
                var minMReal = qntMesSet * 30 * 24 * 60;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minMReal;
            } else {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, qntDiaSet);
                
                var minMReal = qntMesSet * 30 * 24 * 60;
                var minDReal = (qntDiaSet*24*60) + minMReal;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
            }

        } else {
            tempoMsg = self.mensagemAvisoMes(0, qntDiaSet);
   
            var minDReal = (qntDiaSet*24*60);
            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
        }
        return tempoMsg;

    };

    this.calculaDiaCorrido = function(widget, preFixCampo, prioridadeNomeResp) {
        var tempoMsg;
        var qntDiaSet = widget.currentRow[preFixCampo + prioridadeNomeResp];
        if (qntDiaSet >= 30) {
            var qntMesSet = parseInt(qntDiaSet / 30);
            qntDiaSet = qntDiaSet - (qntMesSet * 30);
            if (qntDiaSet == 0) {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, 0);
                 var minMReal = qntMesSet * 30 * 24 * 60;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minMReal;
            } else {
                tempoMsg = self.mensagemAvisoMes(qntMesSet, qntDiaSet);
                 var minMReal = qntMesSet * 30 * 24 * 60;
                var minDReal = (qntDiaSet*24*60) + minMReal;
                widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
            }
        } else {
            tempoMsg = self.mensagemAvisoMes(0, qntDiaSet);
            
            var minDReal = (qntDiaSet*24*60);
            widget.currentRow[preFixCampo+'REAL' + prioridadeNomeResp] = minDReal;
        }
        return tempoMsg;
    };
    
    this.verificaMaiorMenor = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var prioridade = args.owner.field.name.replace('_OPTION','');
        var nome = prioridade.split("RESPONDER");
        var prioridadeNomeResp;
        var prioridadeNomeRelv;
        var tempoResposta;
        var tempoResolucao;
        if (nome.length === 2) {
            prioridadeNomeResp = nome[1];
            prioridadeNomeRelv = nome[1];
        } else {
            nome = prioridade.split("RESOLVER");
            if (nome.length === 2) {
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            } else {
                nome = prioridade.split("NRHORATRAB");
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            }
        }
        
        if (!Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) && !Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) && widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] != null) {
     
                var tipoResposta = widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] ;
                var tipoResolver = widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] 
                var tempoTextResp;
                var tempoResp = widget.currentRow['RESPONDER' + prioridadeNomeResp];
                var tempoTextResv;
                var tempoResv = widget.currentRow['RESOLVER' + prioridadeNomeResp];
                
                if(tipoResposta == tipoResolver){
                    if(tempoResp > tempoResv){
                        ScreenService.showMessage('Tempo de Resolução menor que o tempo de Resposta');
                        widget.currentRow['RESOLVER' + prioridadeNomeResp] = "";
                    }
                }else{
                    /*RESPONDER*/
                     if (tipoResposta == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResp = tempoResp;
                    } else if (tipoResposta == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResp = tempoResp * 60;
                        tempoResp = tempoTextResp;
                    } else if (tipoResposta == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;

                    } else if (tipoResposta == 4) { /*Se o tempo estiver em dias*/
                        tempoTextResp = tempoResp * 60 * 24;
                        tempoResp = tempoTextResp;
                        
                    } else if (tipoResposta == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResp = tempoResp * 60 * 24 * 30;
                        tempoResp = tempoTextResp;
                    }
                    
                    /*RESOLVER*/
                    if (tipoResolver == 1) { /*Se o tempo estiver em mintos*/
                        tempoTextResv = tempoResv;
                    } else if (tipoResolver == 2) { /*Se o tempo estiver em horas*/
                        tempoTextResv = tempoResv * 60;
                        tempoResv = tempoTextResv;
                    } else if (tipoResolver == 3) { /*Se o tempo estiver em dias*/
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                    } else if (tipoResolver == 4) { 
                        tempoTextResv = tempoResv * 60 * 24;
                        tempoResv = tempoTextResv;
                        
                    }else if (tipoResolver == 5) { /*Se o tempo estiver em meses*/
                        tempoTextResv = tempoResv * 60 * 24 * 30;
                        tempoResv = tempoTextResv;
                    }
                    
                    if(tempoResp > tempoResv){
                        ScreenService.showMessage('Tempo de Resposta maior que o tempo de Resolução');
                        widget.currentRow['RESPONDER' + prioridadeNomeResp] = "";
                    }
                    
                }
        }        
    };

    this.setAviso = function(args) {
        var widget = templateManager.container.getActiveWidget();
        var prioridade = args.owner.field.name.replace('_OPTION','');
        var nome = prioridade.split("RESPONDER");
        var prioridadeNomeResp;
        var prioridadeNomeRelv;
        var tempoResposta;
        var tempoResolucao;

        if (nome.length === 2) {
            prioridadeNomeResp = nome[1];
            prioridadeNomeRelv = nome[1];
        } else {
            nome = prioridade.split("RESOLVER");
            if (nome.length === 2) {
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            } else {
                nome = prioridade.split("NRHORATRAB");
                prioridadeNomeRelv = nome[1];
                prioridadeNomeResp = nome[1];
            }
        }


        if (!Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) && !Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) && widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] != null) {

            var NRHORATRAB = widget.currentRow['NRHORATRAB' + prioridadeNomeRelv];
            restEngine.post("product#/crud/crm_horatrab", {
                'requestType': 'FilterData',
                filter: [{
                    operator: "=",
                    name: "NRHORATRAB",
                    value: NRHORATRAB
                }]
            }).
            then(function(response) {
                var slaqdhora = response.dataset.crm_horatrab;
                var quadroHorario = slaqdhora[0].NMHORARIO; /*Pega nome do quatro de horario utilizado*/
                var QNTHRTRABSEGUNDA = parseInt(slaqdhora[0].QNTHRTRABSEGUNDA.replace(':', ''));
                var QNTHRTRABTERCA = parseInt(slaqdhora[0].QNTHRTRABTERCA.replace(':', ''));
                var QNTHRTRABQUARTA = parseInt(slaqdhora[0].QNTHRTRABQUARTA.replace(':', ''));
                var QNTHRTRABQUINTA = parseInt(slaqdhora[0].QNTHRTRABQUINTA.replace(':', ''));
                var QNTHRTRABSEXTA = parseInt(slaqdhora[0].QNTHRTRABSEXTA.replace(':', ''));
                var QNTHRTRABSABADO = parseInt(slaqdhora[0].QNTHRTRABSABADO.replace(':', ''));
                var QNTHRTRABDOMINGO = parseInt(slaqdhora[0].QNTHRTRABDOMINGO.replace(':', ''));
                var IDABERTO_SEGUNDA = slaqdhora[0].IDABERTO_SEGUNDA;
                var IDABERTO_TERCA = slaqdhora[0].IDABERTO_TERCA;
                var IDABERTO_QUARTA = slaqdhora[0].IDABERTO_QUARTA;
                var IDABERTO_QUINTA = slaqdhora[0].IDABERTO_QUINTA;
                var IDABERTO_SEXTA = slaqdhora[0].IDABERTO_SEXTA;
                var IDABERTO_SABADO = slaqdhora[0].IDABERTO_SABADO;
                var IDABERTO_DOMINGO = slaqdhora[0].IDABERTO_DOMINGO;
                var idAberto = [IDABERTO_SEGUNDA, IDABERTO_TERCA, IDABERTO_QUARTA, IDABERTO_QUINTA, IDABERTO_SEXTA, IDABERTO_SABADO, IDABERTO_DOMINGO];
                var diasAbertos = idAberto.filter(function(dia) {
                    return dia == "S";
                });
                var qntHRStrab = [QNTHRTRABSEGUNDA, QNTHRTRABTERCA, QNTHRTRABQUARTA, QNTHRTRABQUINTA, QNTHRTRABSEXTA, QNTHRTRABSABADO, QNTHRTRABDOMINGO];
   
                /*calcula tempoo real de resposta*/
                if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 1) {
                    tempoResposta = self.calculaMinuto(widget, 'RESPONDER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 2) {
                    tempoResposta = self.calculaHora(widget, 'RESPONDER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 3) {

                    tempoResposta = self.calculaDiaUtil(widget, 'RESPONDER', prioridadeNomeResp, diasAbertos);


                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 4) {
                    tempoResposta = self.calculaDiaCorrido(widget, 'RESPONDER', prioridadeNomeResp);

                } else if (widget.currentRow['RESPONDER' + prioridadeNomeResp + '_OPTION'] == 5) {

                    tempoResposta = self.calculaMesUtil(widget, 'RESPONDER', prioridadeNomeResp, diasAbertos);
                }

                /*calcula tempo real de resolver*/
                if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 1) {
                    tempoResolucao = self.calculaMinuto(widget, 'RESOLVER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 2) {
                    tempoResolucao = self.calculaHora(widget, 'RESOLVER', prioridadeNomeResp, qntHRStrab);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 3) {
                    tempoResolucao = self.calculaDiaUtil(widget, 'RESOLVER', prioridadeNomeResp, diasAbertos);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 4) {
                    tempoResolucao = self.calculaDiaCorrido(widget, 'RESOLVER', prioridadeNomeResp);

                } else if (widget.currentRow['RESOLVER' + prioridadeNomeResp + '_OPTION'] == 5) {
                    tempoResolucao = self.calculaMesUtil(widget, 'RESOLVER', prioridadeNomeResp, diasAbertos);

                }

                /*Ativa o SPAN*/
                widget.getField('AVISO' + prioridadeNomeResp).isVisible = true;

                /*Seta texto no span*/
                widget.currentRow['AVISO' + prioridadeNomeResp] = " Tempo real de resposta é: " + tempoResposta + " | Tempo real de Resolução é: " + tempoResolucao + " (Tempo calculado de acordo com a parametrização do " + quadroHorario + ")";
            }.bind(this));



        }
        if (Util.isEmptyOrBlank(widget.currentRow['RESPONDER' + prioridadeNomeResp]) || Util.isEmptyOrBlank(widget.currentRow['RESOLVER' + prioridadeNomeRelv]) || widget.currentRow['NRHORATRAB' + prioridadeNomeRelv] == null) {
            widget.getField('AVISO' + prioridadeNomeResp).isVisible = false;
        }

    };

    this.filtraDataSource = function(widget) {
        var wid = templateManager.container.getWidget('WDGT_VINCULO_SLA_CLIENTE').dataSource.data;

        var rows = [];
        rows = wid.map(function(row) {
            return row['NRPARCNEGOCIO'];
        });
        if (rows && rows.length > 0) {
            widget.dataSourceFilter = [{
                    "name": "NRORG",
                    "operator": "IN",
                    "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
                },
                {
                    "name": "NRPARCNEGOCIO",
                    "operator": "NOT_IN",
                    "value": rows
                }

            ];
        }
        widget.clearSearchList();
        widget.clearSearchCriteria();
        widget.reload();
    };

    this.filtroVinculo = function(widget) {
        widget.dataSourceFilter = [
            {
                "name": "NRORG",
                "operator": "IN",
                "value": "@[getLocalVar('CRM_NRORGTRAB'), getLocalVar('CRM_NRORGPADRAO')]@"
            },
            {
                "name": "NRSEQSLA",
                "operator": "=",
                "value": widget.parent.parent.currentRow.NRSEQSLA
            }
        ];
        if(widget.lastFilter !== widget.parent.parent.currentRow.NRSEQSLA){
            widget.reload();
            widget.lastFilter = widget.parent.parent.currentRow.NRSEQSLA;
        }
        

    };
    
    this.ocultaAviso = function() {
       
        var nomePrioridades = self.nomePrioridades();
        nomePrioridades.forEach(function(nomePrioridade){
            
            var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
            setTimeout(function() {
            if(wid.mode == "edit"){
                wid.getField('AVISO'+nomePrioridade).isVisible = false;
            }else{
                wid.getField('AVISO'+nomePrioridade).isVisible = true;
            }
            }, 4);
        });
    };
    
    this.formataFiel = function() {
         setTimeout(function() {
            var nomePrioridades = self.nomePrioridades();
            nomePrioridades.forEach(function(nomePrioridade){
                var wid = templateManager.container.getWidget('WDGT_CADASTRO_SLA');
                if(wid.mode == "edit"){
                    wid.getField('RESPONDER'+nomePrioridade).class = "textSelect";
                     wid.getField('RESOLVER'+nomePrioridade).class = "textSelect";
                }else if(wid.mode == "view"){
                    wid.getField('RESPONDER'+nomePrioridade).class = 3;
                    wid.getField('RESOLVER'+nomePrioridade).class = 3;
                }
                
            });
             
         }, 4); 
        
    };
    
    this.selecionarProdutoCliente = function(widget) {
        if(widget.getCheckedRows().length == 0){
            ScreenService.showMessage('Selecione um produto');
        }else{
            var dataset = {};
            var trataCheckedRows = widget.getCheckedRows();
            dataset.rows = trataCheckedRows.map(function(trataCheckedRow){
                var NRTPARVPROD = trataCheckedRow.NRTPARVPROD;
                var NRARVOREPROD = parseInt(trataCheckedRow.PARENT.replace(NRTPARVPROD, ''));
                
                if(NRTPARVPROD == NRARVOREPROD){
                    trataCheckedRow.NRTPARVPROD = NRTPARVPROD;
                    trataCheckedRow.NRARVOREPROD = NRTPARVPROD;
                }else{
                    trataCheckedRow.NRTPARVPROD = NRTPARVPROD;
                    trataCheckedRow.NRARVOREPROD = NRARVOREPROD;
                }
                
                return trataCheckedRow;
            });
            dataset.nrslaparcnegocio = widget.parent.parent.currentRow.NRSLAPARCNEGOCIO;
            
            
                 General.callRestEngine("product#/crm_sla_vincula/parcnegocioSlaProduto", "DataSet", [dataset]).then(function(response) {
                ScreenService.closeSwipe().then(function() {

                    widget.reload();
                    widget.parent.parent.reload();
                 
                });

            }.bind(this));
            
            
            
        }
    };
    
    this.filtroProdutoParc = function(widget) {
        var NRPARCNEGOCIO = widget.parent.parent.currentRow.NRPARCNEGOCIO;
        var NRSEQSLA = widget.parent.parent.currentRow.NRSEQSLA;
        widget.dataSourceFilter = [
                                            {
                                                "name": "NRORG",
                                                "operator": "=",
                                                "value": "@[getLocalVar('CRM_NRORGTRAB')]@"
                                            },
                                            {
                                                "name": "NRPARCNEGOCIO",
                                                "operator": "=",
                                                "value": NRPARCNEGOCIO
                                            },
                                            {
                                                "name": "NRSEQSLA",
                                                "operator": "=",
                                                "value": NRSEQSLA
                                            }
                                            ];
       
        widget.reload();
    };
    
    this.filtroProduto = function(widget) {
         var wid = templateManager.container.getWidget('WDGT_CLIENTES_PRODUTO').dataSource.data;

        var rows = [];
        rows = wid.map(function(row) {
            return row['CDPRODUTO'];
        });
         if (rows && rows.length > 0) {
             widget.dataSourceFilter = [
                                            {
                                                "name": "NRORG",
                                                "operator": "=",
                                                "value": "@getLocalVar('CRM_NRORGTRAB')@"
                                            },
                                            {
                                                "name": "NRTPARVPROD",
                                                "operator": "=",
                                                "value": ""
                                            },
                                            {
                                                "name": "ID",
                                                "operator": "NOT_IN",
                                                "value": rows
                                            }
                                            ];
             widget.reload();
         }
        
    };
    
}

Configuration(function(ContextRegister) {
    ContextRegister.register("crm_cadastro_slaController", crm_cadastro_slaController);
});