<?php
namespace Teknisa\CRM\Util;

use \Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use \Zeedhi\Framework\DB\StoredProcedure\Param;

class NovoCodigo
{

    public static function geraCodigo($connection, $contador, $nrorg){
        $procedure = new StoredProcedure($connection, 'NOVO_CODIGO');
        $procedure->addParam(new Param('P_CONTADOR'  , Param::PARAM_INPUT , $contador, Param::PARAM_TYPE_STR    ));
        $procedure->addParam(new Param('P_SEQUENCIAL', Param::PARAM_OUTPUT, null     , Param::PARAM_TYPE_STR, 20));
        $procedure->addParam(new Param('P_QTDE'      , Param::PARAM_INPUT , 1        , Param::PARAM_TYPE_INT    ));
        $procedure->addParam(new Param('P_NRORG'     , Param::PARAM_INPUT , $nrorg   , Param::PARAM_TYPE_INT    ));
        $novocodigo = $procedure->execute();
        $intSeq =  (int)$novocodigo['P_SEQUENCIAL'];

        return $intSeq;
    }
}